# coding: utf-8

"""
    MoneyBox

    MoneyBox will help you better understand your finances, improve financial literacy, and achieve financial goals.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, constr

class IncomeCategory(BaseModel):
    """
    IncomeCategory
    """
    id: StrictInt = Field(...)
    created_at: datetime = Field(..., description="Date and time of creation")
    updated_at: datetime = Field(..., description="Date and time of last update")
    is_deleted: Optional[StrictBool] = None
    name: constr(strict=True, max_length=255) = Field(..., description="Name of the income category")
    group: StrictInt = Field(..., description="Group that the income category belongs to")
    created_by: StrictInt = Field(..., description="Profile that created the income category")
    __properties = ["id", "created_at", "updated_at", "is_deleted", "name", "group", "created_by"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IncomeCategory:
        """Create an instance of IncomeCategory from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "id",
                            "created_at",
                            "updated_at",
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IncomeCategory:
        """Create an instance of IncomeCategory from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IncomeCategory.parse_obj(obj)

        _obj = IncomeCategory.parse_obj({
            "id": obj.get("id"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "is_deleted": obj.get("is_deleted"),
            "name": obj.get("name"),
            "group": obj.get("group"),
            "created_by": obj.get("created_by")
        })
        return _obj


